import matplotlib.pyplot as plt
import numpy as np
#import pandas as pd
from matplotlib.ticker import FormatStrFormatter

#Modélisation de la déclinaison :
J=np.arange(1, 365, 0.01)
declinmodel=23.44*np.sin(2*np.pi/365*(284+J))

def duree(latitude):#calcule la durée du jour pour une latitude donnée
    Hzero=np.degrees(np.arccos(-np.tan(latitude)*np.tan(np.radians(declinmodel))))
    return 2*Hzero/15

fig, ax=plt.subplots(figsize=(8, 8))#dimensions de la figure

for phi in [0, 15, 45, 60, 70, 80]:#latitude en degrés
    plt.plot(J, duree(np.radians(phi)), label="latitude : %s°" %(phi))

plt.legend()
plt.title("Durée du jour au cours de l'année", fontsize=14, pad=20)

#------Reglages en x (angles) :---------------------------------------

dates=[1, 32, 60, 91, 121, 152, 182, 213, 244, 274, 305, 335]#coordonnées du 1er jour du mois
initiale=["J", "F", "M", "A", "M", "J", "J", "A", "S", "O", "N", "D"]#initiale du mois
plt.xticks(dates, initiale)
plt.yticks(np.arange(0, 24, 2))
plt.xlim(1, 365)
plt.ylim(0, 24)

ax.yaxis.set_major_formatter(FormatStrFormatter('%.0f h'))
plt.grid()
fig.savefig('DureeDuJour.png', transparent=False, dpi=300)# Création image PNG 
plt.show()
